// SPhraseDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SPhrase.h"
#include "SPhraseDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// the file type avaliable from the load dialog box
const char CSPhraseDlg::szFilters[] =
	"Phrase Files (*.phr)|*.phr|Text Files (*.txt)|*.txt|All Files (*.*)|*.*||";

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSPhraseDlg dialog

CSPhraseDlg::CSPhraseDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSPhraseDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSPhraseDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_hLogo = AfxGetApp()->LoadIcon(IDI_LOGO);
}

void CSPhraseDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSPhraseDlg)
	DDX_Control(pDX, IDC_BUTMORE, m_ButtonMore);
	DDX_Control(pDX, IDC_OUTPUT, m_output);
	DDX_Control(pDX, IDC_IMPRESSIVE, m_impressive);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSPhraseDlg, CDialog)
	//{{AFX_MSG_MAP(CSPhraseDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTMORE, OnButtonMore)
	ON_WM_CONTEXTMENU()
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(IDM_ABOUTBOX, OnAboutBox)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSPhraseDlg message handlers

BOOL CSPhraseDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hLogo, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	// set up the impressiv-o-meter
	m_impressive.SetRange(0, 9);
	m_impressive.SetPos(4);

	// initalize the random number generator
	srand( (unsigned) time(NULL) );

	// atempt to load an inital script
	if (generator.loadDefinition(startupScript))
		// make phrase from it if sucessfull
		m_output.SetWindowText(generator.makeAPhrase(rand(), 5));
	else	
		// report errors if not
		m_output.SetWindowText(startupScript + " \r\n" + generator.getErrors() + generator.getWarnings());

	// make the more button an icon button
	m_ButtonMore.PostMessage(BM_SETIMAGE, IMAGE_ICON, (long)m_hIcon);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSPhraseDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSPhraseDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSPhraseDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSPhraseDlg::OnButtonMore() 
{
	// generates a new silly phrase and sets the edit
	//  control's contents to the result
	m_output.SetWindowText(generator.makeAPhrase(rand(), m_impressive.GetPos()));	
	//m_output.SetWindowText(generator.getAll());	
}

void CSPhraseDlg::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	// should be fairly standard context menu stuff,
	//  except I'm not sure if I really needed to use the
	//  sub menu...
	CRect rect;
	GetClientRect(&rect);
	ClientToScreen(&rect);
	
	if (rect.PtInRect(point))
	{
		CMenu menu;
		menu.LoadMenu(IDR_CONTEXTMENU);
		CMenu* pContextMenu = menu.GetSubMenu(0);
		
		pContextMenu->TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON |
			TPM_RIGHTBUTTON, point.x, point.y, this);
		return;
	}
	CDialog::OnContextMenu(pWnd, point);
}

// displays the file load dialog box, and sets
//  the output window's text to any error that occured
//  during the load
void CSPhraseDlg::OnFileOpen()
{
	CFileDialog dlg (TRUE, "phr", "*.phr",
		OFN_FILEMUSTEXIST | OFN_READONLY | OFN_HIDEREADONLY, szFilters, this);

	if (dlg.DoModal() == IDOK)
	{
		generator.loadDefinition(dlg.GetPathName());
		m_output.SetWindowText(dlg.GetPathName() + " \r\n" + generator.getErrors() + generator.getWarnings());
	}
}

// handles the about box if it was selected from the context menu
void CSPhraseDlg::OnAboutBox()
{
	CAboutDlg dlg;
	dlg.DoModal();
}
